Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("../ActionTypes");
var getSceneInitState_1 = require("./getSceneInitState");
function sceneReducer(state, action, sceneReducerKey) {
    if (state === void 0) { state = getSceneInitState_1.default(); }
    if (action._sceneReducerKey !== sceneReducerKey)
        return state;
    switch (action.type) {
        case ActionTypes_1.default.ARENA_SCENE_SET_STATE:
            return Object.assign({}, state, action.state);
        case ActionTypes_1.default.ARENA_SCENE_REPLACE_STATE:
            return Object.assign({}, action.state);
        default:
            return state;
    }
}
function createSceneReducer(extendSceneReducer, initState, sceneReducerKey) {
    return function (state, action) {
        if (state === void 0) { state = initState; }
        if (extendSceneReducer) {
            state = extendSceneReducer(state, action, sceneReducerKey);
        }
        return sceneReducer(state, action, sceneReducerKey);
    };
}
exports.default = createSceneReducer;
